float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;



float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Scale : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;

static float Si=Scale*0.1;


float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION  < string Object = "Camera"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float4   LightPosition    : POSITION < string Object = "Light"; >;
static float3 LightDir = normalize(-LightDirection);
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;



float ClearDepth = 1.0;
float4 ClearColor = float4(0, 0, 0, 0);

float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5, 0.5) / ViewportSize);
static float2 SampStep1 = SampStep * 2;
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 1920;

#define SAMPNUM 16


texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;


texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler TexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MipFilter = LINEAR;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;



	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;

	return Out;

}
float4 PS_passB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp,Tex);
	float3 ColorB=Color.rgb;
	ColorB.rgb=pow(ColorB.rgb,2.2);
	float LengthC=length(ColorB.rgb);

        float Point=0.8+Y;
	ColorB.rgb=normalize(ColorB.rgb)*(pow((LengthC-Point),(X+1.3))*sign(LengthC-Point)+Point);
	//ColorB.rgb=pow((ColorB.rgb),(X*0.5+1.0));
	ColorB.rgb=pow(ColorB.rgb,1.0/2.2);
	Color.rgb=lerp(Color.rgb,ColorB.rgb,Tr);
	

	return Color;
}



////////////////////////////////////////////////////////////////////////////////////////////////



technique TechOneMap <
	string Script =


	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"
	

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=B;"
	;
>
{
	pass B < string Script = "Draw=Buffer;"; > {
		//AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passB();
	}
}

